Last Comment Bug 95323 - ckfw should support cipher operations.
: ckfw should support cipher operations.
Status: RESOLVED FIXED
:
Product: NSS
Classification: Components
Component: Libraries (show other bugs)
: 3.3.1
: x86 All
: P3 normal (vote)
: 3.12
Assigned To: Robert Relyea
:
Mentors:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2001-08-14 19:29 PDT by zhoubin
Modified: 2007-09-05 17:47 PDT (History)
4 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---


Attachments
Implement the basic Cryptographic operations needed for a typical readonly 'smart card' (133.48 KB, patch)
2005-11-04 12:22 PST, Robert Relyea
no flags Details | Diff | Splinter Review
Complete the needed framework functions. (171.76 KB, patch)
2005-11-14 13:29 PST, Robert Relyea
kaie: superreview+
Details | Diff | Splinter Review
Turn off capi builds unless an NSS_BUILD_CAPI is set, or MOZILLA_CLIENT is set (309 bytes, patch)
2006-01-09 17:22 PST, Robert Relyea
julien.pierre: review+
Details | Diff | Splinter Review

Description zhoubin 2001-08-14 19:29:47 PDT
I'm write pkcs11 module using nss's ckfw.But ckfw does not support cipher 
operations,such as digest,sign.(the wrapped function's implementation is empty).
Comment 1 Wan-Teh Chang 2001-08-14 22:29:46 PDT
Assigned the bug to Bob.
Comment 2 Robert Relyea 2001-08-15 10:05:33 PDT
Yup, that's on the list.;).

bob
Comment 3 Wan-Teh Chang 2001-10-31 19:09:06 PST
Bob, I assume you plan to address this issue in NSS 3.4?
Comment 4 Robert Relyea 2001-11-01 10:51:45 PST
It would be nice, but I really think it's a 4.0 feature.

I'm using the softoken in 3.4

bob
Comment 5 Wan-Teh Chang 2002-04-25 16:35:33 PDT
Changed the QA contact to Bishakha.
Comment 6 Robert Relyea 2005-11-04 12:22:25 PST
Created attachment 201870 [details] [diff] [review]
Implement the basic Cryptographic operations needed for a typical readonly 'smart card'

This patch implments all the XXXXX_Init XXXXX_Update XXXXXX_Final and XXXXX (update and final) as well as the combo operations.

It does not implement the basic key operations: wrap, unwrap, keygen, etc.
The basic flow is the token returns mechanism structures for each mechanism it implements. These structures supply the XXXX_Init operations, which return a CryptoOperation structure. The latter is stored in PKCS #11 by class (as the PKCS #11 spec specifies), and are used to fulfill the subsequent update, updateDigest final, etc operations.

bob
Comment 7 Robert Relyea 2005-11-04 12:25:08 PST
The patch is long, but very repetitive.
Comment 8 Robert Relyea 2005-11-04 12:25:55 PST
set target milestone.
Comment 9 Robert Relyea 2005-11-14 13:29:13 PST
Created attachment 203033 [details] [diff] [review]
Complete the needed framework functions.

Here is the 'final' patch. I'm sure we will need to make updates as this code gets more use, but this should provide a good base usage for implementing tokens which do crypto.

this patch is needed for the capi pkcs #11 module to build.
Comment 10 Kai Engert (:kaie) 2005-12-15 01:29:12 PST
Comment on attachment 203033 [details] [diff] [review]
Complete the needed framework functions.

You are often derefencing pointers without having checked for null. Please decide yourself whether you want to add some checks.
Comment 11 Robert Relyea 2006-01-09 17:22:00 PST
Created attachment 208039 [details] [diff] [review]
Turn off capi builds unless an NSS_BUILD_CAPI is set, or MOZILLA_CLIENT is set

Patch to allow older window developement environments to continue to build NSS.
Comment 12 Robert Relyea 2006-01-13 16:10:58 PST
Comment on attachment 208039 [details] [diff] [review]
Turn off capi builds unless an NSS_BUILD_CAPI is set, or MOZILLA_CLIENT is set

Oops, I guess I forgot to put Julien on the review.

bob
Comment 13 Robert Relyea 2007-05-08 15:03:30 PDT
Comment on attachment 203033 [details] [diff] [review]
Complete the needed framework functions.

This bug just needs a second review. The patch has been in NSS 3.12 for ages.

Alexi, feel free to punt the review to someone else if you are loaded.

bob
Comment 14 Nelson Bolyard (seldom reads bugmail) 2007-05-08 23:45:52 PDT
Bob, out of curiosity, what/who needs this before 3.12?
Comment 15 Robert Relyea 2007-05-09 10:31:36 PDT
rob can use it. I wouldn't say it is critical.

Mostly, I misunderstood target email, and thought it was the list of things that were targetted for 3.11.7. After I realized the truth, I also realized that this would be a nice have.

It's not a high priority item.

bob
Comment 16 Robert Relyea 2007-08-30 17:44:26 PDT
Comment on attachment 203033 [details] [diff] [review]
Complete the needed framework functions.

we don't really need this in 3.11.x. dropping review request.
Comment 17 Nelson Bolyard (seldom reads bugmail) 2007-08-30 17:50:50 PDT
Agreed.
Comment 18 Julien Pierre 2007-09-05 16:07:50 PDT
So, should this bug be resolved fixed then ?
Comment 19 Robert Relyea 2007-09-05 17:47:19 PDT
yes.

Note You need to log in before you can comment on or make changes to this bug.